unit UHighscore;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, mmsystem, ZLib, Buttons;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    Path: TFileName;
    Highscore: array[1..10] of packed record
                                 Euro: Single;
                                 Name: string[15];
                                 DateTime: TDateTime;
                               end;
    HighscoreOutput: array[1..10] of record
                                       Euro, DateTime: TLabel;
                                       Name: TEdit;
                                     end;
    procedure LoadHighscore;
    procedure SaveHighscore;
    procedure RefreshOutput;
  public
    { Public-Deklarationen }
    NewScore: Single;
  end;

var
  Form2: TForm2;

implementation

uses UMain;

{$R *.dfm}

procedure TForm2.FormCreate(Sender: TObject);
var i: Integer;
begin
  for i:=1 to 10 do
    with HighscoreOutput[i] do begin
      Euro:=TLabel(FindComponent('Label'+IntToStr(i+14)));
      Name:=TEdit(FindComponent('Edit'+IntToStr(i)));
      DateTime:=TLabel(FindComponent('Label'+IntToStr(i+24)));
    end;
  for i:=1 to 10 do
    with Highscore[i] do begin
      Euro:=0;
      Name:='';
      DateTime:=0;
    end;
  NewScore:=0;
  Path:=ExtractFilePath(ParamStr(0));
end;

procedure TForm2.FormShow(Sender: TObject);
var i, j: Integer;
begin
  LoadHighscore;
  if newscore<=Highscore[10].Euro then begin
    if newscore>0 then
      Form1.PlaySnd('SND_BOO', SND_RESOURCE or SND_ASYNC);
    newscore:=0;
  end else begin
    for i:=1 to 10 do
      if newscore>Highscore[i].Euro then begin
        for j:=10 downto i+1 do
          Highscore[j]:=Highscore[j-1];
        case i of
          1: Form1.PlaySnd('SND_CLAP', SND_RESOURCE or SND_ASYNC);
          2..9: Form1.PlaySnd('SND_CASHREG', SND_RESOURCE or SND_ASYNC);
          10: Form1.PlaySnd('SND_COIN', SND_RESOURCE or SND_ASYNC);
        end;
        Highscore[i].Euro:=newscore;
        Highscore[i].Name:='';
        Highscore[i].DateTime:=now;
        RefreshOutput;
        HighscoreOutput[i].Name.Enabled:=True;
        Break;
      end;
  end;
end;

procedure TForm2.FormHide(Sender: TObject);
var i: Integer;
begin
  if newscore>0 then begin
    for i:=1 to 10 do begin
      Highscore[i].Name:=HighscoreOutput[i].Name.Text;
      HighscoreOutput[i].Name.Enabled:=False;
    end;
    SaveHighscore;
    newscore:=0;
  end;
end;

procedure TForm2.LoadHighscore;
var
  InputStream: TFileStream;
  OutputStream: TMemoryStream;
  DeCompressionStream: ZLib.TDeCompressionStream;
  Buf: array[0..4095] of Byte;
  Count: Integer;
begin
  if FileExists(Path+'Highscore.dat') then begin
    InputStream:=TFileStream.Create(Path+'Highscore.dat', fmOpenRead);
    try
      OutputStream:=TMemoryStream.Create;
      try
        DecompressionStream := TDecompressionStream.Create(InputStream);
        try
          while True do begin
            Count := DecompressionStream.Read(Buf[0], SizeOf(Buf));
            if Count = 0 then
              break
            else
              OutputStream.Write(Buf[0], Count);
          end;
        finally
          DecompressionStream.Free;
        end;
      finally
        OutputStream.Position:=0;
        OutputStream.ReadBuffer(Highscore, SizeOf(Highscore));
        OutputStream.Free;
      end;
    finally
      InputStream.Free;
    end;
    RefreshOutput;
  end;
end;

procedure TForm2.SaveHighscore;
var
  OutputStream: TFileStream;
  CompressionStream: ZLib.TCompressionStream;
begin
  OutputStream:=TFileStream.Create(Path+'Highscore.dat', fmCreate);
  try
    CompressionStream:=TCompressionStream.Create(clMax, OutputStream);
    try
      CompressionStream.WriteBuffer(Highscore, SizeOf(Highscore));
    finally
      CompressionStream.Free;
    end;
  finally
    OutputStream.Free;
  end;
end;

procedure TForm2.RefreshOutput;
var i: Integer;
begin
  for i:=1 to 10 do
    if Highscore[i].DateTime=0 then begin
      HighscoreOutput[i].Euro.Caption:='-';
      HighscoreOutput[i].Name.Text:='';
      HighscoreOutput[i].DateTime.Caption:='-'
    end else begin
      HighscoreOutput[i].Euro.Caption:=Format('%6.2f', [Highscore[i].Euro]);
      HighscoreOutput[i].Name.Text:=Highscore[i].Name;
      HighscoreOutput[i].DateTime.Caption:=FormatDateTime('dd.mm.yy', Highscore[i].DateTime)+' / '+
                                           FormatDateTime('hh:mm', Highscore[i].DateTime);
    end;
end;

procedure TForm2.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key=VK_RETURN then
    Close;
end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

end.
